<?php
namespace Modules\Fornecimento\Modules\AutorizacaoFornecimento\Services;

class AprovacaoAlcadasService
{
    public function __construct($connection)
    {
        $this->connection = $connection;
    }
    
    public function getAlcadas($conditions)
    {
        $sql = "SELECT APROVALCADA.NRAPROVALCADA, APROVALCADA.NRCONFIGALCADA, CONFIGALCADA.NMALCADA, CONFIGALCADA.IDTIPOVRAPROV, APROVALCADA.CDFILDEST, APROVALCADA.CDFILLANC, APROVALCADA.NRDEMANDA, APROVALCADA.IDTPDEMANDA, APROVALCADA.IDCLASSIFIC, APROVALCADA.IDAPROVADO, TO_CHAR(APROVALCADA.DTINCLUSAO, 'DD/MM/YYYY') AS DTINCLUSAO, ALCADAGERFILI.CDOPERADOR APROVADOR, ALCADAGERFILI.VRAPROVCMP, FILIAL.NMFILIAL NMFILDEST, AUTOFORNE.VRTOTALAF, AUTOFORNE.DSMOTVAFALCADA, FORNECEDOR.NRINSJURFORN, FORNECEDOR.NMRAZSOCFORN, FORNECEDOR.NMFANTFORN, APROVALCADA.NRORG, (SELECT MIN(ITEMAUTF.DTPROGENTAF) FROM ITEMAUTF WHERE ITEMAUTF.CDFILDEST = AUTOFORNE.CDFILDEST AND ITEMAUTF.CDFILLANC = AUTOFORNE.CDFILLANC AND ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN) DTPROGENTAF, ORCAMENTREALOC.VRORCAMENTO, ORCAMENTREALOC.VRREALIZADO, ORCAMENTREALOC.VRDIFERENCA FROM APROVALCADA INNER JOIN CONFIGALCADA ON APROVALCADA.NRCONFIGALCADA = CONFIGALCADA.NRCONFIGALCADA INNER JOIN ALCADAGERFILI ON APROVALCADA.NRCONFIGALCADA = ALCADAGERFILI.NRCONFIGALCADA AND APROVALCADA.CDFILDEST = ALCADAGERFILI.CDFILIAL AND APROVALCADA.CDOPERADOR = ALCADAGERFILI.CDOPERADOR INNER JOIN FILIAL ON APROVALCADA.CDFILDEST = FILIAL.CDFILIAL INNER JOIN AUTOFORNE ON APROVALCADA.CDFILDEST = AUTOFORNE.CDFILDEST AND APROVALCADA.CDFILLANC = AUTOFORNE.CDFILLANC AND APROVALCADA.NRDEMANDA = AUTOFORNE.NRAUTOFORN INNER JOIN FORNECEDOR ON AUTOFORNE.CDFORNECED = FORNECEDOR.CDFORNECED INNER JOIN (SELECT ORCAMENTREALOC.VRORCAMENTO, ORCAMENTREALOC.VRREALIZADO, ORCAMENTREALOC.VRDIFERENCA, ITEMAUTF.CDFILDEST, ITEMAUTF.CDFILLANC, ITEMAUTF.NRAUTOFORN FROM ITEMAUTF INNER JOIN ORCAMENTREALOC ON ITEMAUTF.CDFILDEST = ORCAMENTREALOC.CDFILIAL INNER JOIN PRODUTO ON ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO WHERE TO_DATE(TO_CHAR(ITEMAUTF.DTPROGENTAF, 'MM/YYYY'), 'MM/YYYY') = TO_DATE(TO_CHAR(ORCAMENTREALOC.DTMESPERIODO, 'MM/YYYY'), 'MM/YYYY') AND ORCAMENTREALOC.IDORIGEM IN ('CONSUMO', 'DESPESA') AND PRODUTO.CDARVPROD LIKE CDNVLARVPROD || '%') ORCAMENTREALOC ON ORCAMENTREALOC.CDFILDEST = AUTOFORNE.CDFILDEST AND ORCAMENTREALOC.CDFILLANC = AUTOFORNE.CDFILLANC AND ORCAMENTREALOC.NRAUTOFORN = AUTOFORNE.NRAUTOFORN WHERE (INSTR(:CDFILIAL, APROVALCADA.CDFILDEST) > 0 OR :CDFILIAL = 'T') AND (INSTR(:NRCONFIGALCADA, CONFIGALCADA.NRCONFIGALCADA) > 0 OR :NRCONFIGALCADA = 'T') AND (INSTR(:IDCLASSIFIC, APROVALCADA.IDCLASSIFIC) > 0 OR :IDCLASSIFIC = 'T') AND (APROVALCADA.DTINCLUSAO BETWEEN :P_DTINCLUSAO_INI AND :P_DTINCLUSAO_FIN OR :P_TDTINCLUSAO = 'T') AND APROVALCADA.IDAPROVADO = :IDAPROVADO AND APROVALCADA.CDOPERADOR = :CDOPERADOR AND EXISTS (SELECT 1 FROM ITEMAUTF WHERE ITEMAUTF.CDFILDEST = AUTOFORNE.CDFILDEST AND ITEMAUTF.CDFILLANC = AUTOFORNE.CDFILLANC AND ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN AND (ITEMAUTF.DTPROGENTAF BETWEEN :P_DTENTREGAAF_INI AND :P_DTENTREGAAF_FIN OR :P_TDTENTREGAAF = 'T'))";
        try {
            $std = $this->connection->prepare($sql);
            $std->execute(
                array (
                    'CDFILIAL'          => $conditions['CDFILIAL'],
                    'CDOPERADOR'        => $conditions['CDOPERADOR'],
                    'IDAPROVADO'        => $conditions['IDAPROVADO'],
                    'IDCLASSIFIC'       => $conditions['IDCLASSIFIC'],
                    'NRCONFIGALCADA'    => $conditions['NRCONFIGALCADA'],
                    'P_DTINCLUSAO_INI'  => $conditions['P_DTINCLUSAO_INI'],
                    'P_DTINCLUSAO_FIN'  => $conditions['P_DTINCLUSAO_FIN'],
                    'P_TDTINCLUSAO'     => $conditions['P_TDTINCLUSAO'],
                    'P_DTENTREGAAF_INI' => $conditions['P_DTENTREGAAF_INI'],
                    'P_DTENTREGAAF_FIN' => $conditions['P_DTENTREGAAF_FIN'],
                    'P_TDTENTREGAAF'    => $conditions['P_TDTENTREGAAF'],
                )
            );
            
            return $std->fetchAll();
        } catch(Exception $e) {
            throw $e;
        }
    }
    
    public function defineColumn($IDAPROVADO)
    {
        if ($IDAPROVADO == 'PENDENTE')
            return 1;
        else if ($IDAPROVADO == 'APROVADO')
            return 2;
        else if ($IDAPROVADO == 'RECUSADO')
            return 3;
    }
    
    public function getNameClassific($IDCLASSIFIC)
    {
        if ($IDCLASSIFIC == 'FORA_ORCAMENTO')
            return 'Fora do Orçamento';
        else if ($IDCLASSIFIC == 'PADRAO')
            return 'Padrão';
        else if ($IDCLASSIFIC == 'EXTRA')
            return 'Extra';
        else
            return $IDCLASSIFIC;
    }
    
    public function getNameIdAprovado($IDAPROVADO)
    {
        if ($IDAPROVADO == 'PENDENTE')
            return 'Pendente';
        else if ($IDAPROVADO == 'APROVADO')
            return 'Aprovado';
        else if ($IDAPROVADO == 'RECUSADO')
            return 'Reprovado';
        else
            return $IDCLASSIFIC;
    }
}
