/* Sistemas Integrados TECNISA

Nome: 0330_PLATRGO.SQL

 Descrio:
 ###########################################################################################
 #             Triggers para atualizao do campo DTULTATURECE da tabela PRATO             #
 ###########################################################################################

Criao:
   05/03/2004 Leonardo Leo de Assis
*/

CREATE OR REPLACE TRIGGER DTULTATU_RECESERV
BEFORE INSERT OR UPDATE OR DELETE
ON RECESERV FOR EACH ROW

DECLARE
V_CDPRATO      RECESERV.CDPRATO%TYPE;
V_CDFILAUXPRAT RECESERV.CDFILAUXPRAT%TYPE;

BEGIN
   IF DELETING THEN
      V_CDPRATO      := :OLD.CDPRATO;
      V_CDFILAUXPRAT := :OLD.CDFILAUXPRAT;
   ELSE
      V_CDPRATO      := :NEW.CDPRATO;
      V_CDFILAUXPRAT := :NEW.CDFILAUXPRAT;
   END IF;

   UPDATE
      PRATO
   SET
      DTULTATURECE = SYSDATE
   WHERE
      (CDPRATO      = V_CDPRATO) AND
      (CDFILAUXPRAT = V_CDFILAUXPRAT);
      
   IF (NOT DELETING) THEN
      :NEW.DTULTATURECS := SYSDATE;
   END IF;
END;
/
